#ifndef GLOBALS_H
#define GLOBALS_H
#include "dlfcn.h"
#include <map>
#include <string>
#include <vector>
#include "object.h"

// Variables definitions
typedef std::map<std::string,ObjectBase*> G_varsType;
extern G_varsType G_vars;

// Functions addresses
typedef std::multimap<std::string,Func> G_funcsType;
extern G_funcsType G_funcs;

typedef std::vector<ObjectList*> G_toType;
// List of objects to save
extern G_toType G_tosave;

// List of objects to print
extern G_toType G_toprint;

// Loaded modules
typedef std::vector<void*> G_libsType;
extern G_libsType G_libs;

void ClearGlobals();

bool Save(const ObjectList* input);
bool Print(const ObjectList* input);

#endif
