#include <math.h>
#include "object.h"

ObjectBase* Arifm_Add(const ObjectList* input)
{
 if(input->Size()!=2) return 0;
 const ObjectBase *arg1=input->At(0),*arg2=input->At(1);
 std::type_index t1(typeid(*arg1)),t2(typeid(*arg2));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 if( (t1!=tr && t1!=ti) || (t2!=tr && t2!=ti) ) return 0;

 // Integer arifmetic
 if(t1==ti && t2==ti) return new ObjectInt(dynamic_cast<const ObjectInt*>(arg1)->Value() + dynamic_cast<const ObjectInt*>(arg2)->Value());

 // Real arifmetic
 double r1,r2;

 if(t1==tr) r1=dynamic_cast<const ObjectReal*>(arg1)->Value();
 else r1=dynamic_cast<const ObjectInt*>(arg1)->Value();

 if(t2==tr) r2=dynamic_cast<const ObjectReal*>(arg2)->Value();
 else r2=dynamic_cast<const ObjectInt*>(arg2)->Value();

 return new ObjectReal(r1+r2);
}


ObjectBase* Arifm_Sub(const ObjectList* input)
{
 if(input->Size()!=2) return 0;
 const ObjectBase *arg1=input->At(0),*arg2=input->At(1);
 std::type_index t1(typeid(*arg1)),t2(typeid(*arg2));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 if( (t1!=tr && t1!=ti) || (t2!=tr && t2!=ti) ) return 0;

 // Integer arifmetic
 if(t1==ti && t2==ti) return new ObjectInt(dynamic_cast<const ObjectInt*>(arg1)->Value() - dynamic_cast<const ObjectInt*>(arg2)->Value());

 // Real arifmetic
 double r1,r2;

 if(t1==tr) r1=dynamic_cast<const ObjectReal*>(arg1)->Value();
 else r1=dynamic_cast<const ObjectInt*>(arg1)->Value();

 if(t2==tr) r2=dynamic_cast<const ObjectReal*>(arg2)->Value();
 else r2=dynamic_cast<const ObjectInt*>(arg2)->Value();

 return new ObjectReal(r1-r2);
}


ObjectBase* Arifm_Mul(const ObjectList* input)
{
 if(input->Size()!=2) return 0;
 const ObjectBase *arg1=input->At(0),*arg2=input->At(1);
 std::type_index t1(typeid(*arg1)),t2(typeid(*arg2));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 if( (t1!=tr && t1!=ti) || (t2!=tr && t2!=ti) ) return 0;

 // Integer arifmetic
 if(t1==ti && t2==ti) return new ObjectInt(dynamic_cast<const ObjectInt*>(arg1)->Value() * dynamic_cast<const ObjectInt*>(arg2)->Value());

 // Real arifmetic
 double r1,r2;

 if(t1==tr) r1=dynamic_cast<const ObjectReal*>(arg1)->Value();
 else r1=dynamic_cast<const ObjectInt*>(arg1)->Value();

 if(t2==tr) r2=dynamic_cast<const ObjectReal*>(arg2)->Value();
 else r2=dynamic_cast<const ObjectInt*>(arg2)->Value();

 return new ObjectReal(r1*r2);
}


ObjectBase* Arifm_Div(const ObjectList* input)
{
 if(input->Size()!=2) return 0;
 const ObjectBase *arg1=input->At(0),*arg2=input->At(1);
 std::type_index t1(typeid(*arg1)),t2(typeid(*arg2));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 if( (t1!=tr && t1!=ti) || (t2!=tr && t2!=ti) ) return 0;

 // Integer arifmetic
 if(t1==ti && t2==ti) return new ObjectInt(dynamic_cast<const ObjectInt*>(arg1)->Value() / dynamic_cast<const ObjectInt*>(arg2)->Value());

 // Real arifmetic
 double r1,r2;

 if(t1==tr) r1=dynamic_cast<const ObjectReal*>(arg1)->Value();
 else r1=dynamic_cast<const ObjectInt*>(arg1)->Value();

 if(t2==tr) r2=dynamic_cast<const ObjectReal*>(arg2)->Value();
 else r2=dynamic_cast<const ObjectInt*>(arg2)->Value();

 return new ObjectReal(r1/r2);
}


ObjectBase* Arifm_Pow(const ObjectList* input)
{
 if(input->Size()!=2) return 0;
 const ObjectBase *arg1=input->At(0),*arg2=input->At(1);
 std::type_index t1(typeid(*arg1)),t2(typeid(*arg2));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 if( (t1!=tr && t1!=ti) || (t2!=tr && t2!=ti) ) return 0;

 // Only real arifmetic
 double r1,r2;

 if(t1==tr) r1=dynamic_cast<const ObjectReal*>(arg1)->Value();
 else r1=dynamic_cast<const ObjectInt*>(arg1)->Value();

 if(t2==tr) r2=dynamic_cast<const ObjectReal*>(arg2)->Value();
 else r2=dynamic_cast<const ObjectInt*>(arg2)->Value();

 return new ObjectReal(pow(r1,r2));
}


ObjectBase* Arifm_Neg(const ObjectList* input)
{
 if(input->Size()!=1) return 0;
 const ObjectBase *arg=input->At(0);
 std::type_index t(typeid(*arg));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 // Integer arifmetic
 if(t==ti) return new ObjectInt(-dynamic_cast<const ObjectInt*>(arg)->Value());
 // Real arifmetic
 if(t==tr) return new ObjectReal(-dynamic_cast<const ObjectReal*>(arg)->Value());

 return 0;
}


ObjectBase* Arifm_Pos(const ObjectList* input)
{
 if(input->Size()!=1) return 0;
 const ObjectBase *arg=input->At(0);
 std::type_index t(typeid(*arg));
 std::type_index tr(typeid(ObjectReal)),ti(typeid(ObjectInt));

 // Integer arifmetic
 if(t==ti) return new ObjectInt(dynamic_cast<const ObjectInt*>(arg)->Value());
 // Real arifmetic
 if(t==tr) return new ObjectReal(dynamic_cast<const ObjectReal*>(arg)->Value());

 return 0;
}
